/*
XOWA: the XOWA Offline Wiki Application
Copyright (C) 2012 gnosygnu@gmail.com

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as
published by the Free Software Foundation, either version 3 of the
License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
package gplx.xowa.parsers.amps; import gplx.*; import gplx.xowa.*; import gplx.xowa.parsers.*;
import gplx.core.btries.*;
public class Xop_amp_trie {
	public static final Btrie_slim_mgr _ = new_(); Xop_amp_trie() {}
	private static Btrie_slim_mgr new_() {// REF.MW: Sanitizer|$wgHtmlEntities; NOTE:added apos
		Btrie_slim_mgr rv = Btrie_slim_mgr.cs_();
		Reg_char(rv,   39, "&apos;");
		Reg_char(rv,  193, "&Aacute;");
		Reg_char(rv,  225, "&aacute;");
		Reg_char(rv,  194, "&Acirc;");
		Reg_char(rv,  226, "&acirc;");
		Reg_char(rv,  180, "&acute;");
		Reg_char(rv,  198, "&AElig;");
		Reg_char(rv,  230, "&aelig;");
		Reg_char(rv,  192, "&Agrave;");
		Reg_char(rv,  224, "&agrave;");
		Reg_char(rv, 8501, "&alefsym;");
		Reg_char(rv,  913, "&Alpha;");
		Reg_char(rv,  945, "&alpha;");
		Reg_char(rv,   38, "&amp;");
		Reg_char(rv, 8743, "&and;");
		Reg_char(rv, 8736, "&ang;");
		Reg_char(rv,  197, "&Aring;");
		Reg_char(rv,  229, "&aring;");
		Reg_char(rv, 8776, "&asymp;");
		Reg_char(rv,  195, "&Atilde;");
		Reg_char(rv,  227, "&atilde;");
		Reg_char(rv,  196, "&Auml;");
		Reg_char(rv,  228, "&auml;");
		Reg_char(rv, 8222, "&bdquo;");
		Reg_char(rv,  914, "&Beta;");
		Reg_char(rv,  946, "&beta;");
		Reg_char(rv,  166, "&brvbar;");
		Reg_char(rv, 8226, "&bull;");
		Reg_char(rv, 8745, "&cap;");
		Reg_char(rv,  199, "&Ccedil;");
		Reg_char(rv,  231, "&ccedil;");
		Reg_char(rv,  184, "&cedil;");
		Reg_char(rv,  162, "&cent;");
		Reg_char(rv,  935, "&Chi;");
		Reg_char(rv,  967, "&chi;");
		Reg_char(rv,  710, "&circ;");
		Reg_char(rv, 9827, "&clubs;");
		Reg_char(rv, 8773, "&cong;");
		Reg_char(rv,  169, "&copy;");
		Reg_char(rv, 8629, "&crarr;");
		Reg_char(rv, 8746, "&cup;");
		Reg_char(rv,  164, "&curren;");
		Reg_char(rv, 8224, "&dagger;");
		Reg_char(rv, 8225, "&Dagger;");
		Reg_char(rv, 8595, "&darr;");
		Reg_char(rv, 8659, "&dArr;");
		Reg_char(rv,  176, "&deg;");
		Reg_char(rv,  916, "&Delta;");
		Reg_char(rv,  948, "&delta;");
		Reg_char(rv, 9830, "&diams;");
		Reg_char(rv,  247, "&divide;");
		Reg_char(rv,  201, "&Eacute;");
		Reg_char(rv,  233, "&eacute;");
		Reg_char(rv,  202, "&Ecirc;");
		Reg_char(rv,  234, "&ecirc;");
		Reg_char(rv,  200, "&Egrave;");
		Reg_char(rv,  232, "&egrave;");
		Reg_char(rv, 8709, "&empty;");
		Reg_char(rv, 8195, "&emsp;");
		Reg_char(rv, 8194, "&ensp;");
		Reg_char(rv,  917, "&Epsilon;");
		Reg_char(rv,  949, "&epsilon;");
		Reg_char(rv, 8801, "&equiv;");
		Reg_char(rv,  919, "&Eta;");
		Reg_char(rv,  951, "&eta;");
		Reg_char(rv,  208, "&ETH;");
		Reg_char(rv,  240, "&eth;");
		Reg_char(rv,  203, "&Euml;");
		Reg_char(rv,  235, "&euml;");
		Reg_char(rv, 8364, "&euro;");
		Reg_char(rv, 8707, "&exist;");
		Reg_char(rv,  402, "&fnof;");
		Reg_char(rv, 8704, "&forall;");
		Reg_char(rv,  189, "&frac12;");
		Reg_char(rv,  188, "&frac14;");
		Reg_char(rv,  190, "&frac34;");
		Reg_char(rv, 8260, "&frasl;");
		Reg_char(rv,  915, "&Gamma;");
		Reg_char(rv,  947, "&gamma;");
		Reg_char(rv, 8805, "&ge;");
		Reg_char(rv,   62, "&gt;");
		Reg_char(rv, 8596, "&harr;");
		Reg_char(rv, 8660, "&hArr;");
		Reg_char(rv, 9829, "&hearts;");
		Reg_char(rv, 8230, "&hellip;");
		Reg_char(rv,  205, "&Iacute;");
		Reg_char(rv,  237, "&iacute;");
		Reg_char(rv,  206, "&Icirc;");
		Reg_char(rv,  238, "&icirc;");
		Reg_char(rv,  161, "&iexcl;");
		Reg_char(rv,  204, "&Igrave;");
		Reg_char(rv,  236, "&igrave;");
		Reg_char(rv, 8465, "&image;");
		Reg_char(rv, 8734, "&infin;");
		Reg_char(rv, 8747, "&int;");
		Reg_char(rv,  921, "&Iota;");
		Reg_char(rv,  953, "&iota;");
		Reg_char(rv,  191, "&iquest;");
		Reg_char(rv, 8712, "&isin;");
		Reg_char(rv,  207, "&Iuml;");
		Reg_char(rv,  239, "&iuml;");
		Reg_char(rv,  922, "&Kappa;");
		Reg_char(rv,  954, "&kappa;");
		Reg_char(rv,  923, "&Lambda;");
		Reg_char(rv,  955, "&lambda;");
		Reg_char(rv, 9001, "&lang;");
		Reg_char(rv,  171, "&laquo;");
		Reg_char(rv, 8592, "&larr;");
		Reg_char(rv, 8656, "&lArr;");
		Reg_char(rv, 8968, "&lceil;");
		Reg_char(rv, 8220, "&ldquo;");
		Reg_char(rv, 8804, "&le;");
		Reg_char(rv, 8970, "&lfloor;");
		Reg_char(rv, 8727, "&lowast;");
		Reg_char(rv, 9674, "&loz;");
		Reg_char(rv, 8206, "&lrm;");
		Reg_char(rv, 8249, "&lsaquo;");
		Reg_char(rv, 8216, "&lsquo;");
		Reg_char(rv,   60, "&lt;");
		Reg_char(rv,  175, "&macr;");
		Reg_char(rv, 8212, "&mdash;");
		Reg_char(rv,  181, "&micro;");
		Reg_char(rv,  183, "&middot;");
		Reg_char(rv, 8722, "&minus;");
		Reg_char(rv,  924, "&Mu;");
		Reg_char(rv,  956, "&mu;");
		Reg_char(rv, 8711, "&nabla;");
		Reg_char(rv,  160, "&nbsp;");
		Reg_char(rv, 8211, "&ndash;");
		Reg_char(rv, 8800, "&ne;");
		Reg_char(rv, 8715, "&ni;");
		Reg_char(rv,  172, "&not;");
		Reg_char(rv, 8713, "&notin;");
		Reg_char(rv, 8836, "&nsub;");
		Reg_char(rv,  209, "&Ntilde;");
		Reg_char(rv,  241, "&ntilde;");
		Reg_char(rv,  925, "&Nu;");
		Reg_char(rv,  957, "&nu;");
		Reg_char(rv,  211, "&Oacute;");
		Reg_char(rv,  243, "&oacute;");
		Reg_char(rv,  212, "&Ocirc;");
		Reg_char(rv,  244, "&ocirc;");
		Reg_char(rv,  338, "&OElig;");
		Reg_char(rv,  339, "&oelig;");
		Reg_char(rv,  210, "&Ograve;");
		Reg_char(rv,  242, "&ograve;");
		Reg_char(rv, 8254, "&oline;");
		Reg_char(rv,  937, "&Omega;");
		Reg_char(rv,  969, "&omega;");
		Reg_char(rv,  927, "&Omicron;");
		Reg_char(rv,  959, "&omicron;");
		Reg_char(rv, 8853, "&oplus;");
		Reg_char(rv, 8744, "&or;");
		Reg_char(rv,  170, "&ordf;");
		Reg_char(rv,  186, "&ordm;");
		Reg_char(rv,  216, "&Oslash;");
		Reg_char(rv,  248, "&oslash;");
		Reg_char(rv,  213, "&Otilde;");
		Reg_char(rv,  245, "&otilde;");
		Reg_char(rv, 8855, "&otimes;");
		Reg_char(rv,  214, "&Ouml;");
		Reg_char(rv,  246, "&ouml;");
		Reg_char(rv,  182, "&para;");
		Reg_char(rv, 8706, "&part;");
		Reg_char(rv, 8240, "&permil;");
		Reg_char(rv, 8869, "&perp;");
		Reg_char(rv,  934, "&Phi;");
		Reg_char(rv,  966, "&phi;");
		Reg_char(rv,  928, "&Pi;");
		Reg_char(rv,  960, "&pi;");
		Reg_char(rv,  982, "&piv;");
		Reg_char(rv,  177, "&plusmn;");
		Reg_char(rv,  163, "&pound;");
		Reg_char(rv, 8242, "&prime;");
		Reg_char(rv, 8243, "&Prime;");
		Reg_char(rv, 8719, "&prod;");
		Reg_char(rv, 8733, "&prop;");
		Reg_char(rv,  936, "&Psi;");
		Reg_char(rv,  968, "&psi;");
		Reg_char(rv,   34, "&quot;");
		Reg_char(rv, 8730, "&radic;");
		Reg_char(rv, 9002, "&rang;");
		Reg_char(rv,  187, "&raquo;");
		Reg_char(rv, 8594, "&rarr;");
		Reg_char(rv, 8658, "&rArr;");
		Reg_char(rv, 8969, "&rceil;");
		Reg_char(rv, 8221, "&rdquo;");
		Reg_char(rv, 8476, "&real;");
		Reg_char(rv,  174, "&reg;");
		Reg_char(rv, 8971, "&rfloor;");
		Reg_char(rv,  929, "&Rho;");
		Reg_char(rv,  961, "&rho;");
		Reg_char(rv, 8207, "&rlm;");
		Reg_char(rv, 8250, "&rsaquo;");
		Reg_char(rv, 8217, "&rsquo;");
		Reg_char(rv, 8218, "&sbquo;");
		Reg_char(rv,  352, "&Scaron;");
		Reg_char(rv,  353, "&scaron;");
		Reg_char(rv, 8901, "&sdot;");
		Reg_char(rv,  167, "&sect;");
		Reg_char(rv,  173, "&shy;");
		Reg_char(rv,  931, "&Sigma;");
		Reg_char(rv,  963, "&sigma;");
		Reg_char(rv,  962, "&sigmaf;");
		Reg_char(rv, 8764, "&sim;");
		Reg_char(rv, 9824, "&spades;");
		Reg_char(rv, 8834, "&sub;");
		Reg_char(rv, 8838, "&sube;");
		Reg_char(rv, 8721, "&sum;");
		Reg_char(rv, 8835, "&sup;");
		Reg_char(rv,  185, "&sup1;");
		Reg_char(rv,  178, "&sup2;");
		Reg_char(rv,  179, "&sup3;");
		Reg_char(rv, 8839, "&supe;");
		Reg_char(rv,  223, "&szlig;");
		Reg_char(rv,  932, "&Tau;");
		Reg_char(rv,  964, "&tau;");
		Reg_char(rv, 8756, "&there4;");
		Reg_char(rv,  920, "&Theta;");
		Reg_char(rv,  952, "&theta;");
		Reg_char(rv,  977, "&thetasym;");
		Reg_char(rv, 8201, "&thinsp;");
		Reg_char(rv,  222, "&THORN;");
		Reg_char(rv,  254, "&thorn;");
		Reg_char(rv,  732, "&tilde;");
		Reg_char(rv,  215, "&times;");
		Reg_char(rv, 8482, "&trade;");
		Reg_char(rv,  218, "&Uacute;");
		Reg_char(rv,  250, "&uacute;");
		Reg_char(rv, 8593, "&uarr;");
		Reg_char(rv, 8657, "&uArr;");
		Reg_char(rv,  219, "&Ucirc;");
		Reg_char(rv,  251, "&ucirc;");
		Reg_char(rv,  217, "&Ugrave;");
		Reg_char(rv,  249, "&ugrave;");
		Reg_char(rv,  168, "&uml;");
		Reg_char(rv,  978, "&upsih;");
		Reg_char(rv,  933, "&Upsilon;");
		Reg_char(rv,  965, "&upsilon;");
		Reg_char(rv,  220, "&Uuml;");
		Reg_char(rv,  252, "&uuml;");
		Reg_char(rv, 8472, "&weierp;");
		Reg_char(rv,  926, "&Xi;");
		Reg_char(rv,  958, "&xi;");
		Reg_char(rv,  221, "&Yacute;");
		Reg_char(rv,  253, "&yacute;");
		Reg_char(rv,  165, "&yen;");
		Reg_char(rv,  376, "&Yuml;");
		Reg_char(rv,  255, "&yuml;");
		Reg_char(rv,  918, "&Zeta;");
		Reg_char(rv,  950, "&zeta;");
		Reg_char(rv, 8205, "&zwj;");
		Reg_char(rv, 8204, "&zwnj;");
		Reg_prefix(rv, Xop_amp_trie_itm.Tid_num_hex, "#x");
		Reg_prefix(rv, Xop_amp_trie_itm.Tid_num_hex, "#X");
		Reg_prefix(rv, Xop_amp_trie_itm.Tid_num_dec, "#");
		return rv;
	}
	private static void Reg_char(Btrie_slim_mgr trie, int char_int, String xml_name_str) {
		byte[] xml_name_bry = Bry_.new_ascii_(xml_name_str);
		Xop_amp_trie_itm itm = new Xop_amp_trie_itm(Xop_amp_trie_itm.Tid_name, char_int, xml_name_bry);
		byte[] key = Bry_.Mid(xml_name_bry, 1, xml_name_bry.length); // ignore & for purpose of trie; EX: "amp;"; NOTE: must keep trailing ";" else "&amp " will be valid;
		trie.Add_obj(key, itm);
	}
	private static void Reg_prefix(Btrie_slim_mgr trie, byte prefix_type, String prefix) {
		byte[] prefix_ary = Bry_.new_ascii_(prefix);
		Xop_amp_trie_itm itm = new Xop_amp_trie_itm(prefix_type, Xop_amp_trie_itm.Char_int_null, prefix_ary);
		trie.Add_obj(prefix_ary, itm);
	}
}
